# class WEBrick::HTTPServlet::ERBHandler

`ERBHandler` evaluates an `ERB` file and returns the result. This handler is automatically used if there are .rhtml files in a directory served by the `FileHandler`.

`ERBHandler` supports GET and POST methods.

The `ERB` file is evaluated with the local variables `servlet_request` and `servlet_response` which are a `WEBrick::HTTPRequest` and `WEBrick::HTTPResponse` respectively.

Example .rhtml file:

    Request to <%= servlet_request.request_uri %>

    Query params <%= servlet_request.query.inspect %>

### Public Class Methods

new(server, name) click to toggle source

Creates a new `ERBHandler` on `server` that will evaluate and serve the `ERB` file `name`

Calls superclass method `WEBrick::HTTPServlet::AbstractServlet::new`

    # File lib/webrick/httpservlet/erbhandler.rb, line 42
    def initialize(server, name)
      super(server, name)
      @script_filename = name
    end

### Public Instance Methods

do_GET(req, res) click to toggle source

Handles GET requests

    # File lib/webrick/httpservlet/erbhandler.rb, line 50
    def do_GET(req, res)
      unless defined?(ERB)
        @logger.warn "#{self.class}: ERB not defined."
        raise HTTPStatus::Forbidden, "ERBHandler cannot work."
      end
      begin
        data = File.open(@script_filename, &:read)
        res.body = evaluate(ERB.new(data), req, res)
        res['content-type'] ||=
          HTTPUtils::mime_type(@script_filename, @config[:MimeTypes])
      rescue StandardError
        raise
      rescue Exception => ex
        @logger.error(ex)
        raise HTTPStatus::InternalServerError, ex.message
      end
    end

Also aliased as: do_POST
do_POST(req, res)

Handles POST requests

Alias for: do_GET

### Private Instance Methods

evaluate(erb, servlet_request, servlet_response) click to toggle source

Evaluates `erb` providing `servlet_request` and `servlet_response` as local variables.

    # File lib/webrick/httpservlet/erbhandler.rb, line 79
    def evaluate(erb, servlet_request, servlet_response)
      Module.new.module_eval{
        servlet_request.meta_vars
        servlet_request.query
        erb.result(binding)
      }
    end